import math
import unittest
from itertools import product

from formgram.grammars.classifiers.chomsky_classifiers import is_right_regular
from formgram.grammars.transformations.regular import to_right_regular_form
from formgram.grammars.utility.monotone.generator import generate_words_limited_by_length
from formgram.grammars.utility.unrestricted.helper import to_backus_naur_form
from formgram.machines.finite_automata.grammar_interface import from_right_regular_grammar
from formgram.machines.finite_automata.simulation_functions import does_accept
from formgram_tests.helper_functions import get_grammars


class TestAutoGeneratedFiniteAutomata(unittest.TestCase):
    def test_from_regular_grammar(self):
        for grammar_file, grammar, tags in get_grammars(chomsky_type=3):
            n = len(grammar["productions"])
            max_wordlen = round(math.log(10 ** 6, n ** 2))
            words = generate_words_limited_by_length(grammar, max_wordlen)
            if not words:
                continue
            with self.subTest(file=grammar_file):
                try:
                    f_grammar = to_right_regular_form(grammar)
                    fa = from_right_regular_grammar(f_grammar)

                except Exception as e:
                    self.fail(msg=e)
                alphabet_star = {word for l in range(max_wordlen + 1) for word in
                                 product(grammar["terminals"], repeat=l)}
                for word in alphabet_star:
                    included = (word in words)
                    simulated = does_accept(fa, word)
                    if included == simulated:
                        pass  # all is well
                    else:
                        self.fail(
                            f"word {word} was {'not' if not included else ''} in the language but {'not' if not simulated else ''} simulated by the fa {grammar_file}")


if __name__ == '__main__':
    unittest.main()
